var Index = new Object();

window.onload = function()
{
    var clockEl = document.getElementById('clock');
    var uptimeEl = document.getElementById('uptime');
    Clock.start(clockEl, uptimeEl);

    // P3-100/200
    Index.sys_temp = document.getElementById('sys_temp');
    Index.core1_temp = document.getElementById('core1_temp');
    Index.core2_temp = document.getElementById('core2_temp');
    Index.ambient_temp = document.getElementById('ambient_temp');

    // P3-300
    Index.front_temp = document.getElementById('front_temp');
    Index.rear_temp = document.getElementById('rear_temp');
    Index.fpga_temp = document.getElementById('fpga_temp');
    Index.dsp_temp = document.getElementById('dsp_temp');

    Index.refresh_temperature();
}

Index.refresh_temperature = function()
{
    var query = new ServerQuery(Index.refresh_temperature_callback);
    query.sendRequest("/get/temperature");

    setTimeout('Index.refresh_temperature()', 5000);
}

function safe_set_element_value(temp, element)
{
    try
    {
        var tempF = Number(((temp * 9) / 5) + 32).toFixed(0);
        element.innerHTML = temp + "&deg;C (" + (tempF) + "&deg;F)";
    }
    catch (e)
    {
        return;
    }
}

Index.refresh_temperature_callback = function()
{
    var parser = new JSONParser(this.request.responseText);
    var json_object;
    try
    {
        json_object = parser.parse();

        // P3-100/200
        safe_set_element_value(json_object.sys, Index.sys_temp);
        safe_set_element_value(json_object.core1, Index.core1_temp);
        safe_set_element_value(json_object.core2, Index.core2_temp);
        safe_set_element_value(json_object.ambient, Index.ambient_temp);

        // P3-300
        safe_set_element_value(json_object.front, Index.front_temp);
        safe_set_element_value(json_object.rear, Index.rear_temp);
        safe_set_element_value(json_object.fpga, Index.fpga_temp);
        safe_set_element_value(json_object.dsp, Index.dsp_temp);
    }
    catch (e)
    {
        return;
    }
}
