function noop(){}

function ServerQuery(onLoad, onError, target)
{
    this.request = null;
    this.onLoad = onLoad;
    this.onError = (onError ? onError : this.defaultError);
    this.target = (target ? target : this);
}

ServerQuery.prototype =
{
    State_UNINITIALISED:0,
    State_LOADING:1,
    State_LOADED:2,
    State_INTERACTIVE:3,
    State_COMPLETE:4,

    // send the request to the server
    sendRequest:function(url, method, params, contentType)
    {
        this.url = encodeURI(url);

        // fill in missing optional arguments
        if (!method)
        {
            method = "GET";
        }
        if (!contentType && (method == "POST"))
        {
            contentType = "application/x-www-form-urlencoded";
        }

        // get a suitable XMLHttpRequest for this web browser
        if (window.XMLHttpRequest)
        {
            this.request = new XMLHttpRequest();
        }
        else if (window.ActiveXObject)
        {
            this.request = new ActiveXObject("Microsoft.XMLHTTP");
        }

        if (this.request)
        {
            // send the query
            try
            {
                var loader = this;
                this.request.open(method, this.url, true);
                this.request.onreadystatechange = function()
                {
                    loader.onReadyStateChange(loader);
                }
                if (contentType)
                {
                    this.request.setRequestHeader("Content-Type", contentType);
                }
                this.request.setRequestHeader("If-Modified-Since", "Sat, 1 Jan 2000 00:00:00 GMT");
                this.request.send(params);
            }
            catch (err)
            {
                this.onError.call(this);
                this.request.onreadystatechange = noop;
            }
        }
    },

    // callback handler
    onReadyStateChange:function()
    {
        try
        {
            if (this.request.readyState == ServerQuery.prototype.State_COMPLETE)
            {
                // callbacks are passed 'this' as a context and can
                // therefore access the properties of ServerQuery
                switch (this.request.status)
                {
                    case 0:
                    case 200:
                    {
                        this.onLoad.call(this.target, this.request);
                        break;
                    }
                    case 204:
                    {
                        // No-Content
                        break;
                    }
                    default:
                    {
                        this.onError.call(this.target);
                        break;
                    }
                }
                this.request.onreadystatechange = noop;
            }
        }
        catch (err)
        {
            this.onError.call(this.target);
            this.request.onreadystatechange = noop;
        }
    },

    defaultError:function()
    {

    }
}
